﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class Point_Counter : MonoBehaviour {

    public Sound_Management sounds;

    public GameObject player;

    public Text points_text;
    public Text endpoints_text;
    public Text bestscore_text;
    public Text lives_text;

    public Line_Effects_Script effects;

    public Test_Movement_Script movement;

    public GameObject canvas;

    public int lives;
    public int points;

    int timer;
    public int timer_seconds;
    int clicktimer;

    bool can_click;
    public bool is_game_over;
    bool passed_0;

    public float distance;

    void Start () {
        points = 0;
        timer = 0;
        timer_seconds = 0;
        clicktimer = 0;
        can_click = true;
        is_game_over = false;
        passed_0 = false;

	}
	
	void Update () {
		if(Input.GetButtonDown("Fire1"))
        //if(Input.GetKeyDown(KeyCode.Space))
        {
            if(is_game_over==false)
            {
                if(can_click==true)
                {
                    CheckPress();
                    can_click = false;
                }
            }
            else
            {
                Time.timeScale = 1f;
                SceneManager.LoadScene("1");
            }
        }
        distance = Mathf.Abs(transform.position.y);

        if(distance<0.05f && can_click==true)
        {
            passed_0 = true;
        }
        if(distance>2.5f && passed_0==true && can_click==true)
        {
            Lose_Life();
            passed_0 = false;
        }
        if (distance > 2.5f && passed_0 == true && can_click == false)
        {
            passed_0 = false;
            can_click = false;
            if(movement.difficulty!=5)
            {
                clicktimer = -40;
            }
        }

        if (can_click==false)
        {
            clicktimer++; 
        }
        if(clicktimer>29)
        {
            can_click = true;
            clicktimer = 0;
        }
        timer++;
        if (timer > 59)
        {
            timer_seconds++;
            timer = 0;
        }
    }

    void CheckPress()
    {
        float dist = Mathf.Abs(transform.position.y);
        if(dist>2.5f)
        {
            //fail
            Lose_Life();
            sounds.Play_bad();
        }
        else
        {
            if (dist > 2.0f)
            {
                points++;
                sounds.Play_random_good();
                effects.set_effect(1);
            }
            else
            {
                if(dist>0.1f)
                {
                    int i= Mathf.FloorToInt(2000 - dist * 1000);
                    points = points + i;
                    sounds.Play_random_good();
                    effects.set_effect(2);
                }
                else
                {
                    points = points + 5000;
                    sounds.Play_random_great();
                    effects.set_effect(3);
                }
            }
        }
        points_text.text = points.ToString();
    }

    void Lose_Life()
    {
        lives--;
        if(lives==0)
        {
            End_Game();
        }
        lives_text.text = lives.ToString();
    }

    void End_Game()
    {
        Check_Score();
        is_game_over = true;
        Time.timeScale = 0f;
        canvas.SetActive(true);

    }

    void Check_Score()
    {
        int high_score = PlayerPrefs.GetInt("HighScore");
        int score = points;
        if(score>high_score)
        {
            PlayerPrefs.SetInt("HighScore",score);
        }
        endpoints_text.text = "Your Score: " + score.ToString();
        bestscore_text.text = "High Score: " + PlayerPrefs.GetInt("HighScore").ToString();
    }
}
