﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Test_Movement_Script : MonoBehaviour {

    public Point_Counter counter;

    public Calculations_Script calcs;
    
    public int difficulty;
    
    float degree;
    public float speed;

    // Use this for initialization
    void Start () {
        degree = 0f;
	}
	
	// Update is called once per frame
	void Update () {
        
        if(counter.is_game_over==false)
        {
            UpgradeDegree();
            upgradeRotation();
            transform.position = new Vector3(transform.position.x, GetPosition(degree, difficulty) * 16, transform.position.z);
            transform.position = new Vector3(transform.position.x + 0.1f * speed, transform.position.y, transform.position.z);
        }
        if(Input.GetKeyDown(KeyCode.Minus))
        {
            difficulty--;
            calcs.ChangeText(difficulty);
        }
        if(Input.GetKeyDown(KeyCode.RightBracket))
        {
            difficulty++;
            calcs.ChangeText(difficulty);
        }
        if (counter.timer_seconds>15)    //change here to 9 I guess
        {
            if(switchDifficulty()==true)
            {
                counter.timer_seconds = 0;
            }
        }
	}

    void UpgradeDegree()
    {
        degree += 2;
        //degree++;
    }

    void upgradeRotation()
    {
        transform.Rotate(0, 0, -6 * Time.deltaTime);    
    }

    float GetPosition(float deg, int dif)
    {
        switch(dif)
        {
            case 1:
                return Sinus(deg);
            case 2:
                return S_Times_S_Half(deg);
            case 3:
                return S_Times_S_Third(deg);
            case 4:
                return S_Times_S_Fifth(deg);
            case 5:
                return S_Times_Cos(deg);
            case 6:
                return S_Times_S_Half_Squared(deg);
            case 7:
                return S_Times_S_Half_Times_S_Quarter(deg);
            case 8:
                return S_Times_S_Half_Cubed(deg);
            case 9:
                return S_Times_S_Third_Squared(deg);
            case 10:
                return S_Times_S_Times_S_Quarter(deg);
            case 11:
                return S_Times_S_Half_Times_S_Third_Times_S_Quarter(deg);
            case 12:
                return S_Times_S_Half_Squared_Times_S_Third(deg);
            default:
                return Sinus(deg);
        }
    }

    bool switchDifficulty()
    {
        if(difficulty==12)
        {
            difficulty = Random.Range(1, 10);
            calcs.ChangeText(difficulty);
            return true;
        }
        else
        {
            if (/*GetPosition(degree, difficulty) == GetPosition(degree, difficulty + 1)*/(GetPosition(degree, difficulty) < 0.01f && GetPosition(degree, difficulty) > -0.01f)&&(GetPosition(degree, difficulty+1) < 0.01f && GetPosition(degree, difficulty+1) > -0.01f))
            {
                difficulty++;
                calcs.ChangeText(difficulty);
                return true;
            }
            else return false;
        }
        
    }

    float Sinus(float deg)
    {
        //Sin(x)
        return Mathf.Sin(deg * Mathf.Deg2Rad);
    }
    float S_Times_S_Half(float deg)
    {
        //Sin(x)*sin(x/2)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin((deg * Mathf.Deg2Rad) /2);
    }
    float S_Times_S_Half_Times_S_Quarter(float deg)
    {
        //sin(x)*sin(x/2)*sin(x/4)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 4 * Mathf.Deg2Rad);
    }
    float S_Times_S_Third(float deg)
    {
        //sin(x)*sin(x/3)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 3 * Mathf.Deg2Rad);
    }
    float S_Times_Cos(float deg)
    {
        //sin(x)*cos(x)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Cos(deg * Mathf.Deg2Rad);
    }
    float S_Times_S_Fifth(float deg)
    {
        //sin(x)*sin(x/5)
        return  Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 5 * Mathf.Deg2Rad);
    }
    float S_Times_S_Half_Squared(float deg)
    {
        //sin(x)*sin(x/2)^2
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad);
    }
    float S_Times_S_Half_Cubed(float deg)
    {
        //sin(x)*sin(x/2)^3
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad);
    }
    float S_Times_S_Half_Squared_Times_S_Third(float deg)
    {
        //sin(x)*sin(x/2)^2*sin(x/3)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 3 * Mathf.Deg2Rad);
    }
    float S_Times_S_Half_Times_S_Third_Times_S_Quarter(float deg)
    {
        //sin(x)*sin(x/2)*sin(x/3)*sin(x/4)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 2 * Mathf.Deg2Rad) * Mathf.Sin(deg / 3 * Mathf.Deg2Rad) * Mathf.Sin(deg / 4 * Mathf.Deg2Rad);
    }
    float S_Times_S_Third_Squared(float deg)
    {
        //sin(x)*sin(x/3)^2
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg / 3 * Mathf.Deg2Rad) * Mathf.Sin(deg / 3 * Mathf.Deg2Rad);
    }
    float S_Times_S_Times_S_Quarter(float deg)
    {
        //sin(x)*sin(x)*sin(x/4)
        return Mathf.Sin(deg * Mathf.Deg2Rad) * Mathf.Sin(deg* Mathf.Deg2Rad) * Mathf.Sin(deg / 4 * Mathf.Deg2Rad);
    }
}
